MeasuresRenderer
Date: 2019-10-22

org.jmol.render

## Class MeasuresRenderer

- java.lang.Object
- - org.jmol.render.ShapeRenderer
  - - org.jmol.render.FontLineShapeRenderer
    - - org.jmol.render.LabelsRenderer
      - - org.jmol.render.MeasuresRenderer

-     public class MeasuresRenderer
      extends LabelsRenderer

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private javajs.util.A4` | `aaT`
    `private int` | `count`
    `private boolean` | `doJustify`
    `private Measurement` | `m`
    `private short` | `mad0`
    `private javajs.util.M3` | `matrixT`
    `private boolean` | `modulating`
    `private java.util.Map<java.lang.Integer,Point3fi>` | `mpts` modulation points, which must be refreshed based on phase of the vibration; keyed on atom index.
    `private Point3fi[]` | `p`

    - ### Fields inherited from class org.jmol.render.LabelsRenderer

      `ascent, atomPt, bgcolix, descent, fidPrevious, labelColix, minZ, pTemp, sppm, textAlign, xy, zSlab`

    - ### Fields inherited from class org.jmol.render.FontLineShapeRenderer

      `asLineOnly, colixA, colixB, dashDots, dashes, dotsOrDashes, draw000, endcap, font3d, fourdots, hDashes, imageFontScaling, ndots, pointT, pointT2, pointT3, pt0, pt0i, pt1, pt2i, s1, s2, sixdots, tickA, tickAs, tickB, tickBs, tickInfo, twodots, vectorT, vectorT2, vectorT3, width`

    - ### Fields inherited from class org.jmol.render.ShapeRenderer

      `colix, exportType, g3d, isExport, mad, ms, myVisibilityFlag, shape, shapeID, tm, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MeasuresRenderer()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected int` | `drawLine(int x1, int y1, int z1, int x2, int y2, int z2, int mad)`
    `private Point3fi` | `getModAtom(int i)`
    `private void` | `getPoints()`
    `protected void` | `initRenderer()`
    `protected boolean` | `render()`
    `private void` | `renderAngle(java.lang.String s, Point3fi a, Point3fi b, Point3fi c)`
    `(package private) void` | `renderDistance(java.lang.String s, Point3fi a, Point3fi b)`
    `private void` | `renderMeasurement(boolean renderLabel)`
    `private void` | `renderPendingMeasurement()`
    `private void` | `renderTorsion(java.lang.String s, Point3fi a, Point3fi b, Point3fi c, Point3fi d)`

    - ### Methods inherited from class org.jmol.render.LabelsRenderer

      `renderLabelOrMeasure`

    - ### Methods inherited from class org.jmol.render.FontLineShapeRenderer

      `checkTickTemps, drawDashed, drawLine2, drawString, drawTicks, fillCylinder, getDiameter, renderLine`

    - ### Methods inherited from class org.jmol.render.ShapeRenderer

      `isVisibleForMe, renderShape, setup, setViewerG3dShapeID`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### doJustify

          private boolean doJustify

    - #### modulating

          private boolean modulating

    - #### mad0

          private short mad0

    - #### mpts

          private java.util.Map<java.lang.Integer,Point3fi> mpts

      modulation points, which must be refreshed based on phase of the vibration; keyed on atom index.

    - #### m

          private Measurement m

    - #### p

          private Point3fi[] p

    - #### count

          private int count

    - #### aaT

          private javajs.util.A4 aaT

    - #### matrixT

          private javajs.util.M3 matrixT

  - ### Constructor Detail

    - #### MeasuresRenderer

          public MeasuresRenderer()

  - ### Method Detail

    - #### initRenderer

          protected void initRenderer()

      Overrides:
        `initRenderer` in class `ShapeRenderer`

    - #### render

          protected boolean render()

      Overrides:
        `render` in class `LabelsRenderer`

    - #### getPoints

          private void getPoints()

    - #### getModAtom

          private Point3fi getModAtom(int i)

    - #### renderMeasurement

          private void renderMeasurement(boolean renderLabel)

    - #### renderDistance

          void renderDistance(java.lang.String s,
                              Point3fi a,
                              Point3fi b)

    - #### renderAngle

          private void renderAngle(java.lang.String s,
                                   Point3fi a,
                                   Point3fi b,
                                   Point3fi c)

    - #### renderTorsion

          private void renderTorsion(java.lang.String s,
                                     Point3fi a,
                                     Point3fi b,
                                     Point3fi c,
                                     Point3fi d)

    - #### renderPendingMeasurement

          private void renderPendingMeasurement()

    - #### drawLine

          protected int drawLine(int x1,
                                 int y1,
                                 int z1,
                                 int x2,
                                 int y2,
                                 int z2,
                                 int mad)

      Overrides:
        `drawLine` in class `FontLineShapeRenderer`